{
    "scan": {
        "analyzer-version-clang": "18.1.2",
        "analyzer-version-cppcheck": "2.13.0",
        "analyzer-version-gcc": "14.0.1",
        "analyzer-version-gcc-analyzer": "14.0.1",
        "analyzer-version-shellcheck": "0.10.0",
        "enabled-plugins": "clang, cppcheck, gcc, shellcheck",
        "exit-code": 0,
        "host": "ip-172-16-1-37.us-west-2.compute.internal",
        "mock-config": "fedora-41-x86_64",
        "project-name": "libarchive-3.7.2-3.fc41",
        "store-results-to": "/tmp/tmpvpi3079j/libarchive-3.7.2-3.fc41.tar.xz",
        "time-created": "2024-04-17 06:12:59",
        "time-finished": "2024-04-17 06:15:40",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'fedora-41-x86_64' '-t' 'shellcheck,clang,cppcheck,gcc' '-o' '/tmp/tmpvpi3079j/libarchive-3.7.2-3.fc41.tar.xz' '--gcc-analyze' '/tmp/tmpvpi3079j/libarchive-3.7.2-3.fc41.src.rpm'",
        "tool-version": "csmock-3.5.3-1.el9"
    },
    "defects": [
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/cpio/cpio.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘mode_pass’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/cpio/cpio.c",
                    "line": 1242,
                    "column": 9,
                    "event": "warning[-Wanalyzer-possible-null-argument]",
                    "message": "use of possibly-NULL ‘*cpio.destdir’ where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/cpio/cpio.c",
                    "line": 1241,
                    "column": 25,
                    "event": "note",
                    "message": "(1) this call could return NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/cpio/cpio.c",
                    "line": 1242,
                    "column": 9,
                    "event": "note",
                    "message": "(2) argument 1 (‘malloc(strlen(destdir) + 8)’) from (1) could be NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<built-in>",
                    "line": 0,
                    "event": "note",
                    "message": "argument 1 of ‘__builtin_memcpy’ must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1240|   \tcpio->destdir_len = strlen(destdir);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1241|   \tcpio->destdir = malloc(cpio->destdir_len + 8);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1242|-> \tmemcpy(cpio->destdir, destdir, cpio->destdir_len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1243|   \tif (cpio->destdir_len == 0 || destdir[cpio->destdir_len - 1] != '/')",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1244|   \t\tcpio->destdir[cpio->destdir_len++] = '/';",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1213,
                    "column": 8,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of null pointer (loaded from variable 's')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1155,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to 'case 512:'  at line 1160",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1162,
                    "column": 3,
                    "event": "note",
                    "message": " Execution continues on line 1170",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1170,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'text' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1170,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1170,
                    "column": 25,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1170,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1178,
                    "column": 4,
                    "event": "note",
                    "message": "Value assigned to 'start'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1179,
                    "column": 8,
                    "event": "note",
                    "message": "'fields' is < 'numfields'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1179,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1180,
                    "column": 5,
                    "event": "note",
                    "message": "The value of 'start' is assigned to field 'start'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1184,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1176,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 1177",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1179,
                    "column": 8,
                    "event": "note",
                    "message": "'fields' is < 'numfields'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1179,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1184,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1176,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1187,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1187,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1187,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1187,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1190",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1190,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'start' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1190,
                    "column": 30,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1201,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1211,
                    "column": 4,
                    "event": "note",
                    "message": "Null pointer value stored to 's'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1213,
                    "column": 8,
                    "event": "note",
                    "message": "Dereference of null pointer (loaded from variable 's')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1211|   \t\t\ts = field[0].start;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1212|   \t\t\tlen = field[0].end - field[0].start;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1213|-> \t\t\tif (*s == L'd' && (len == 1 || (len >= 7",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1214|   \t\t\t    && wmemcmp((s + 1), L\"efault\", 6) == 0))) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1215|   \t\t\t\ttype = ARCHIVE_ENTRY_ACL_TYPE_DEFAULT;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1696,
                    "column": 8,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of null pointer (loaded from variable 's')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1635,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to 'case 512:'  at line 1640",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1642,
                    "column": 3,
                    "event": "note",
                    "message": " Execution continues on line 1650",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1653,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'text' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1653,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1653,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1653,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1661,
                    "column": 4,
                    "event": "note",
                    "message": "Value assigned to 'start'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1662,
                    "column": 8,
                    "event": "note",
                    "message": "'fields' is < 'numfields'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1662,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1663,
                    "column": 5,
                    "event": "note",
                    "message": "The value of 'start' is assigned to field 'start'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1667,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1659,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 1660",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1662,
                    "column": 8,
                    "event": "note",
                    "message": "'fields' is < 'numfields'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1662,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1667,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1659,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1670,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1670,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1670,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1670,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1673",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1673,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'start' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1673,
                    "column": 30,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1684,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1694,
                    "column": 4,
                    "event": "note",
                    "message": "Null pointer value stored to 's'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_acl.c",
                    "line": 1696,
                    "column": 8,
                    "event": "note",
                    "message": "Dereference of null pointer (loaded from variable 's')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1694|   \t\t\ts = field[0].start;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1695|   \t\t\tlen = field[0].end - field[0].start;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1696|-> \t\t\tif (*s == 'd' && (len == 1 || (len >= 7",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1697|   \t\t\t    && memcmp((s + 1), \"efault\", 6) == 0))) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1698|   \t\t\t\ttype = ARCHIVE_ENTRY_ACL_TYPE_DEFAULT;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_blake2s_ref.c",
                    "line": 89,
                    "event": "warning[uninitvar]",
                    "message": "Uninitialized variable: P->digest_length",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   87|       S->h[i] ^= load32( &p[i * 4] );",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   88|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   89|->   S->outlen = P->digest_length;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   90|     return 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   91|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_blake2sp_ref.c",
                    "line": 41,
                    "event": "warning[uninitvar]",
                    "message": "Uninitialized variable: P->inner_length",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   39|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   40|     int err = blake2s_init_param(S, P);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   41|->   S->outlen = P->inner_length;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   42|     return err;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   43|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_match.c",
                    "line": 237,
                    "event": "error[memleak]",
                    "message": "Memory leak: a",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  235|   \tmatch_list_init(&(a->inclusion_gnames));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  236|   \ttime(&a->now);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  237|-> \treturn (&(a->archive));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  238|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_match.c",
                    "line": 608,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_match.c",
                    "line": 608,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  606|   \t\treturn (ARCHIVE_FATAL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  607|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  608|-> \tr = archive_read_support_format_raw(ar);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  609|   \tr = archive_read_support_format_empty(ar);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  610|   \tif (r != ARCHIVE_OK) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 692,
                    "column": 5,
                    "event": "warning[core.CallAndMessage]",
                    "message": "1st function call argument is an uninitialized value",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1161,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'NumStats' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1161,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1201,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1201,
                    "column": 5,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1207,
                    "column": 7,
                    "event": "note",
                    "message": "Calling 'Ppmd8_UpdateBin'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1102,
                    "column": 55,
                    "event": "note",
                    "message": "Assuming field 'Freq' is >= 196",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1105,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'NextContext'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1066,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'OrderFall' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1066,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1066,
                    "column": 28,
                    "event": "note",
                    "message": "Assuming 'c' is < field 'UnitsStart'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1066,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 1070,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'UpdateModel'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 807,
                    "column": 42,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 838,
                    "column": 10,
                    "event": "note",
                    "message": "Field 'OrderFall' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 838,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 838,
                    "column": 28,
                    "event": "note",
                    "message": "Assuming 'fSuccessor' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 838,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 840,
                    "column": 18,
                    "event": "note",
                    "message": "Calling 'CreateSuccessors'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 620,
                    "column": 8,
                    "event": "note",
                    "message": "'skip' is 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 620,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 623,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 658",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 660,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming field 'Symbol' is < 64",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 660,
                    "column": 67,
                    "event": "note",
                    "message": "Assuming field 'Symbol' is < 64",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 662,
                    "column": 10,
                    "event": "note",
                    "message": "Field 'NumStats' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 662,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 678,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming field 'HiUnit' is not equal to field 'LoUnit'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 678,
                    "column": 5,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_ppmd8.c",
                    "line": 692,
                    "column": 5,
                    "event": "note",
                    "message": "1st function call argument is an uninitialized value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  690|       *ONE_STATE(c1) = upState;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  691|       c1->Suffix = REF(c);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  692|->     SetSuccessor(ps[--numPs], REF(c1));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  693|       c = c1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  694|     }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function '__archive_rb_tree_swap_prune_and_rebalance'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 63,
                    "column": 11,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL 'standin'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 374,
                    "column": 44,
                    "event": "note",
                    "message": "in expansion of macro 'RB_POSITION'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 492,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to '__archive_rb_tree_remove_node'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 515,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'self' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 42,
                    "column": 41,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 53,
                    "column": 35,
                    "event": "note",
                    "message": "in definition of macro 'RB_SENTINEL_P'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 54,
                    "column": 53,
                    "event": "note",
                    "message": "in expansion of macro 'rb_left'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 58,
                    "column": 28,
                    "event": "note",
                    "message": "in expansion of macro 'RB_LEFT_SENTINEL_P'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 515,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'RB_CHILDLESS_P'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 60,
                    "column": 25,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 520,
                    "column": 14,
                    "event": "note",
                    "message": "in expansion of macro 'RB_TWOCHILDREN_P'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 63,
                    "column": 11,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 538,
                    "column": 17,
                    "event": "note",
                    "message": "in expansion of macro 'RB_POSITION'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 544,
                    "column": 19,
                    "event": "note",
                    "message": "(6) calling '__archive_rb_tree_iterate' from '__archive_rb_tree_remove_node'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 675,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to '__archive_rb_tree_iterate'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 680,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'self' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 692,
                    "column": 41,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 53,
                    "column": 35,
                    "event": "note",
                    "message": "in definition of macro 'RB_SENTINEL_P'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 692,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 544,
                    "column": 19,
                    "event": "note",
                    "message": "(12) returning to '__archive_rb_tree_remove_node' from '__archive_rb_tree_iterate'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 545,
                    "column": 9,
                    "event": "note",
                    "message": "(13) calling '__archive_rb_tree_swap_prune_and_rebalance' from '__archive_rb_tree_remove_node'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 371,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to '__archive_rb_tree_swap_prune_and_rebalance'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 63,
                    "column": 11,
                    "event": "note",
                    "message": "(15) dereference of NULL 'standin'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_rb.c",
                    "line": 374,
                    "column": 44,
                    "event": "note",
                    "message": "in expansion of macro 'RB_POSITION'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   61|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   62|   #define\tRB_POSITION(rb)\t\\",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   63|->     (((rb)->rb_info & RB_FLAG_POSITION) ? RB_DIR_RIGHT : RB_DIR_LEFT)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   64|   #define\tRB_RIGHT_P(rb)\t\t(RB_POSITION(rb) == RB_DIR_RIGHT)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   65|   #define\tRB_LEFT_P(rb)\t\t(RB_POSITION(rb) == RB_DIR_LEFT)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_add_passphrase.c",
                    "line": 84,
                    "event": "error[memleak]",
                    "message": "Memory leak: p.passphrase",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   82|   \t\treturn (NULL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   83|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   84|-> \treturn (p);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   85|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   86|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 743,
                    "column": 5,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'flags' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 743,
                    "column": 5,
                    "event": "note",
                    "message": "Value stored to 'flags' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  741|   \t\t\t\tt->restore_time.noatime = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  742|   \t\t\telse if (errno == EPERM)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  743|-> \t\t\t\tflags &= ~O_NOATIME;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  744|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  745|   #endif",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'setup_sparse'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1208,
                    "column": 20,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of '*t.sparse_list'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1203,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1204,
                    "column": 23,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1206,
                    "column": 34,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1208,
                    "column": 20,
                    "event": "note",
                    "message": "(4) '*t.sparse_list' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1206|   \t\tt->sparse_list = malloc(sizeof(t->sparse_list[0]) *",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1207|   \t\t    t->sparse_list_size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1208|-> \t\tif (t->sparse_list == NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1209|   \t\t\tt->sparse_list_size = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1210|   \t\t\tarchive_set_error(&a->archive, ENOMEM,",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tree_reopen'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2238,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor '*t.initial_dir_fd'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1319,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 98,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_private.h",
                    "line": 152,
                    "column": 20,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1323,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro 'archive_check_magic'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1326,
                    "column": 9,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1328,
                    "column": 17,
                    "event": "note",
                    "message": "(4) calling '_archive_read_disk_open' from 'archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1363,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to '_archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1367,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1369,
                    "column": 22,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1368,
                    "column": 27,
                    "event": "note",
                    "message": "(8) calling 'tree_reopen' from '_archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2197,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'tree_reopen'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2210,
                    "column": 57,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'restore_time != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2211,
                    "column": 18,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2227,
                    "column": 9,
                    "event": "note",
                    "message": "(12) calling 'tree_push' from 'tree_reopen'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2123,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'tree_push'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2129,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'te' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2131,
                    "column": 21,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2145,
                    "column": 12,
                    "event": "note",
                    "message": "(16) following 'false' branch (when 'rt' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2153,
                    "column": 1,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2227,
                    "column": 9,
                    "event": "note",
                    "message": "(18) returning to 'tree_reopen' from 'tree_push'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2230,
                    "column": 29,
                    "event": "note",
                    "message": "(19) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2238,
                    "column": 12,
                    "event": "note",
                    "message": "(20) '*t.initial_dir_fd' leaks here; was opened at (19)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2236|   \t * unhelpful and unnecessary errors later.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2237|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2238|-> \tif (t->initial_dir_fd < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2239|   \t\tt->initial_dir_fd = open(\".\", o_flag | O_CLOEXEC);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2240|   #endif",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2239,
                    "column": 35,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor '*t.initial_dir_fd'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1319,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_private.h",
                    "line": 152,
                    "column": 20,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1323,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro 'archive_check_magic'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1326,
                    "column": 9,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1328,
                    "column": 17,
                    "event": "note",
                    "message": "(4) calling '_archive_read_disk_open' from 'archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1363,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to '_archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1367,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1369,
                    "column": 22,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1368,
                    "column": 27,
                    "event": "note",
                    "message": "(8) calling 'tree_reopen' from '_archive_read_disk_open'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2197,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'tree_reopen'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2210,
                    "column": 57,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'restore_time != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2211,
                    "column": 18,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2227,
                    "column": 9,
                    "event": "note",
                    "message": "(12) calling 'tree_push' from 'tree_reopen'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2123,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'tree_push'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2129,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'te' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2131,
                    "column": 21,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2145,
                    "column": 12,
                    "event": "note",
                    "message": "(16) following 'false' branch (when 'rt' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2153,
                    "column": 1,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2227,
                    "column": 9,
                    "event": "note",
                    "message": "(18) returning to 'tree_reopen' from 'tree_push'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2238,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2239,
                    "column": 37,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2239,
                    "column": 37,
                    "event": "note",
                    "message": "(21) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2239,
                    "column": 35,
                    "event": "note",
                    "message": "(22) '*t.initial_dir_fd' leaks here; was opened at (21)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2237|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2238|   \tif (t->initial_dir_fd < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2239|-> \t\tt->initial_dir_fd = open(\".\", o_flag | O_CLOEXEC);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2240|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2241|   \t__archive_ensure_cloexec_flag(t->initial_dir_fd);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2374,
                    "column": 13,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'next' results in a dereference of a null pointer (loaded from variable 'te')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1116,
                    "column": 8,
                    "event": "note",
                    "message": "Calling '_archive_read_next_header2'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1128,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_private.h",
                    "line": 152,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'archive_check_magic'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1128,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_private.h",
                    "line": 152,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'archive_check_magic'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1128,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_private.h",
                    "line": 149,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'archive_check_magic'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1133,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'entry_fd' is < 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1133,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1140,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 1141,
                    "column": 7,
                    "event": "note",
                    "message": "Calling 'next_entry'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 857,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.h",
                    "line": 74,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'archive_string_init'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 863,
                    "column": 11,
                    "event": "note",
                    "message": "Calling 'tree_next'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2391,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming field 'stack' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2391,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2393,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'd' is equal to INVALID_DIR_HANDLE",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2393,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2400,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2400,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2409,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2409,
                    "column": 10,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2422,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2422,
                    "column": 10,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2424,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'tree_dir_next_posix'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2451,
                    "column": 9,
                    "event": "note",
                    "message": "Field 'd' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2451,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2466,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'd' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2466,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2467,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'tree_ascend'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2289,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2289,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2295,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'new_fd' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2295,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2304,
                    "column": 3,
                    "event": "note",
                    "message": "Value assigned to field 'stack'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2305,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2305,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2467,
                    "column": 8,
                    "event": "note",
                    "message": "Returning from 'tree_ascend'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2468,
                    "column": 4,
                    "event": "note",
                    "message": "Calling 'tree_pop'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2371,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'stack' is equal to field 'current'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2371,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2371,
                    "column": 32,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2371,
                    "column": 32,
                    "event": "note",
                    "message": "Assuming field 'current' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2371,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2373,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer value stored to 'te'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_disk_posix.c",
                    "line": 2374,
                    "column": 13,
                    "event": "note",
                    "message": "Access to field 'next' results in a dereference of a null pointer (loaded from variable 'te')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2372|   \t\tt->current = t->current->parent;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2373|   \tte = t->stack;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2374|-> \tt->stack = te->next;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2375|   \tt->dirname_length = te->dirname_length;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2376|   \tt->basename = t->path.s + t->dirname_length;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'peek_at_header'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 197,
                    "column": 37,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'strdup(p + (sizetype)len)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 334,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'consume_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 344,
                    "column": 15,
                    "event": "note",
                    "message": "(2) calling 'peek_at_header' from 'consume_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 130,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'peek_at_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 150,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 153,
                    "column": 13,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 153,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 156,
                    "column": 15,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 156,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 162,
                    "column": 12,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 180,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 189,
                    "column": 28,
                    "event": "note",
                    "message": "(12) following 'false' branch (when 'p' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 191,
                    "column": 27,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 194,
                    "column": 20,
                    "event": "note",
                    "message": "(14) following 'true' branch (when 'state' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 196,
                    "column": 35,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 197,
                    "column": 39,
                    "event": "note",
                    "message": "(16) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_gzip.c",
                    "line": 197,
                    "column": 37,
                    "event": "note",
                    "message": "(17) 'strdup(p + (sizetype)len)' leaks here; was allocated at (16)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  195|   \t\t\t/* Reset the name in case of repeat header reads. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  196|   \t\t\tfree(state->name);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  197|-> \t\t\tstate->name = strdup((const char *)&p[file_start]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  198|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  199|   #endif",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'lz4_allocate_out_block'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 262,
                    "column": 12,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'out_block'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 374,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'lz4_filter_read_descriptor'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 386,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 396,
                    "column": 39,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 398,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 401,
                    "column": 12,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 401,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 403,
                    "column": 57,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 412,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 415,
                    "column": 29,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 452,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 457,
                    "column": 9,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 460,
                    "column": 13,
                    "event": "note",
                    "message": "(12) calling 'lz4_allocate_out_block' from 'lz4_filter_read_descriptor'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 243,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'lz4_allocate_out_block'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 249,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 251,
                    "column": 18,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 251,
                    "column": 12,
                    "event": "note",
                    "message": "(16) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 252,
                    "column": 27,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 253,
                    "column": 46,
                    "event": "note",
                    "message": "(18) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 255,
                    "column": 20,
                    "event": "note",
                    "message": "(19) assuming 'out_block' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 255,
                    "column": 20,
                    "event": "note",
                    "message": "(20) following 'false' branch (when 'out_block' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 260,
                    "column": 34,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 262,
                    "column": 12,
                    "event": "note",
                    "message": "(22) 'out_block' leaks here; was allocated at (18)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  260|   \t\tstate->out_block = out_block;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  261|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  262|-> \tif (!state->flags.block_independence)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|   \t\tmemset(state->out_block, 0, 64 * 1024);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   \treturn (ARCHIVE_OK);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 263,
                    "column": 17,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'out_block'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 374,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'lz4_filter_read_descriptor'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 386,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 396,
                    "column": 39,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 398,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 401,
                    "column": 12,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 401,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 403,
                    "column": 57,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 412,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 415,
                    "column": 29,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 452,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 457,
                    "column": 9,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 460,
                    "column": 13,
                    "event": "note",
                    "message": "(12) calling 'lz4_allocate_out_block' from 'lz4_filter_read_descriptor'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 243,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'lz4_allocate_out_block'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 249,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 250,
                    "column": 32,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 251,
                    "column": 12,
                    "event": "note",
                    "message": "(16) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 252,
                    "column": 27,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 253,
                    "column": 46,
                    "event": "note",
                    "message": "(18) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 255,
                    "column": 20,
                    "event": "note",
                    "message": "(19) assuming 'out_block' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 255,
                    "column": 20,
                    "event": "note",
                    "message": "(20) following 'false' branch (when 'out_block' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 260,
                    "column": 34,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 262,
                    "column": 12,
                    "event": "note",
                    "message": "(22) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 263,
                    "column": 29,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_lz4.c",
                    "line": 263,
                    "column": 17,
                    "event": "note",
                    "message": "(24) 'out_block' leaks here; was allocated at (18)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  261|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  262|   \tif (!state->flags.block_independence)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|-> \t\tmemset(state->out_block, 0, 64 * 1024);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   \treturn (ARCHIVE_OK);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  265|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_read_support_filter_program_signature'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 153,
                    "column": 17,
                    "event": "warning[-Wanalyzer-possible-null-argument]",
                    "message": "use of possibly-NULL 'malloc(signature_len)' where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 144,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'state' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 146,
                    "column": 22,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 147,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 150,
                    "column": 23,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 150,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 151,
                    "column": 38,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 152,
                    "column": 36,
                    "event": "note",
                    "message": "(7) this call could return NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_program.c",
                    "line": 153,
                    "column": 17,
                    "event": "note",
                    "message": "(8) argument 1 ('malloc(signature_len)') from (7) could be NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<built-in>",
                    "line": 0,
                    "event": "note",
                    "message": "argument 1 of '__builtin_memcpy' must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|   \t\tstate->signature_len = signature_len;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|   \t\tstate->signature = malloc(signature_len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|-> \t\tmemcpy(state->signature, signature, signature_len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  155|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 835,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'get_line'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 182,
                    "column": 20,
                    "event": "warning[-Wanalyzer-infinite-loop]",
                    "message": "infinite loop",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 262,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'uudecode_bidder_bid'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 211,
                    "column": 1,
                    "event": "note",
                    "message": "(2) entry to 'bid_get_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 177,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'get_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 182,
                    "column": 20,
                    "event": "note",
                    "message": "(4) infinite loop here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 182,
                    "column": 20,
                    "event": "note",
                    "message": "(5) when 'avail > len': always following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 183,
                    "column": 31,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 183,
                    "column": 17,
                    "event": "note",
                    "message": "(7) if it ever follows 'default:' branch, it will always do so...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(9) looping back...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 182,
                    "column": 20,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  181|   \tlen = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  182|-> \twhile (len < avail) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  183|   \t\tswitch (ascii[*b]) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  184|   \t\tcase 0:\t/* Non-ascii character or control character. */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'ensure_in_buff_size'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 437,
                    "column": 40,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'ptr'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 459,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'uudecode_filter_read'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 483,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 487,
                    "column": 21,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 487,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 493,
                    "column": 40,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 492,
                    "column": 21,
                    "event": "note",
                    "message": "(6) calling 'ensure_in_buff_size' from 'uudecode_filter_read'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 403,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to 'ensure_in_buff_size'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 407,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 423,
                    "column": 23,
                    "event": "note",
                    "message": "(10) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 424,
                    "column": 20,
                    "event": "note",
                    "message": "(11) assuming 'ptr' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 424,
                    "column": 20,
                    "event": "note",
                    "message": "(12) following 'false' branch (when 'ptr' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 432,
                    "column": 29,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 432,
                    "column": 20,
                    "event": "note",
                    "message": "(14) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 433,
                    "column": 25,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 437,
                    "column": 40,
                    "event": "note",
                    "message": "(16) 'ptr' leaks here; was allocated at (10)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  435|   \t\tfree(uudecode->in_buff);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  436|   \t\tuudecode->in_buff = ptr;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  437|-> \t\tuudecode->in_allocated = newsize;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  438|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   \treturn (ARCHIVE_OK);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 495,
                    "column": 3,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 472,
                    "column": 2,
                    "event": "note",
                    "message": "Value assigned to 'd'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 473,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'd' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 473,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 473,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'avail_in' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 473,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 477,
                    "column": 6,
                    "event": "note",
                    "message": "'d' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 477,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 483,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'state' is not equal to ST_IGNORE",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 483,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 487,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'in_cnt' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 487,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 492,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_filter_uu.c",
                    "line": 495,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  493|   \t\t    avail_in + uudecode->in_cnt) != ARCHIVE_OK)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  494|   \t\t\treturn (ARCHIVE_FATAL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  495|-> \t\tmemcpy(uudecode->in_buff + uudecode->in_cnt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  496|   \t\t    d, avail_in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  497|   \t\td = uudecode->in_buff;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 829,
                    "column": 4,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 665,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 665,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 670,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'archive_format_name' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 670,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 673,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'entries' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 673,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 688,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'entries_remaining' is > 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 688,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 688,
                    "column": 37,
                    "event": "note",
                    "message": "Assuming 'zip_entry' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 688,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 697,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'sconv' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 697,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 708,
                    "column": 6,
                    "event": "note",
                    "message": "'zip_entry' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 708,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 708,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'folderIndex' is >= field 'numFolders'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 708,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 726,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 730,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_entry_locale.h",
                    "line": 82,
                    "column": 39,
                    "event": "note",
                    "message": "expanded from macro 'archive_entry_copy_pathname_l'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 730,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 748,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 748,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 751,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 751,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 754,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 754,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 757,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 757,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 769,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 769,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 798,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'entry_bytes_remaining' is >= 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 798,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 801,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 801,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 809,
                    "column": 15,
                    "event": "note",
                    "message": "Field 'entry_bytes_remaining' is > 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 809,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 815,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'archive_read_format_7zip_read_data'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 864,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 868,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'pack_stream_bytes_unconsumed' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 868,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 873,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer value stored to 'buff'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 878,
                    "column": 11,
                    "event": "note",
                    "message": "Field 'end_of_entry' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 878,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 883,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'bytes_to_read' is <= field 'entry_bytes_remaining'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 883,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 886,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'read_stream'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 3380,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'uncompressed_buffer_bytes_remaining' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 3380,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 3381,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'pack_stream_inbytes_remaining' is > 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 3381,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 3383,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'r' is < 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 3383,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 3384,
                    "column": 5,
                    "event": "note",
                    "message": "Returning without writing to '*'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 886,
                    "column": 10,
                    "event": "note",
                    "message": "Returning from 'read_stream'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 887,
                    "column": 6,
                    "event": "note",
                    "message": "'bytes' is < 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 887,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 815,
                    "column": 8,
                    "event": "note",
                    "message": "Returning from 'archive_read_format_7zip_read_data'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 817,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 817,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 822,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'mem' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 822,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 829,
                    "column": 4,
                    "event": "note",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  827|   \t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  828|   \t\t\tsymname = mem;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  829|-> \t\t\tmemcpy(symname+symsize, buff, size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  830|   \t\t\tsymsize += size;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  831|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 2620,
                    "column": 9,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'p' is used in the enclosing expression, the value is never actually read from 'p'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_7zip.c",
                    "line": 2620,
                    "column": 9,
                    "event": "note",
                    "message": "Although the value stored to 'p' is used in the enclosing expression, the value is never actually read from 'p'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2618|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2619|   \t\t\t/* Skip one byte. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2620|-> \t\t\tif ((p = header_bytes(a, 1)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2621|   \t\t\t\treturn (-1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2622|   \t\t\tll--;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_cab.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 11681 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3054,
                    "column": 16,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'key' results in a dereference of an undefined pointer value",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1177,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'archive_format' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1177,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1182,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'current_position' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1182,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1190,
                    "column": 6,
                    "event": "note",
                    "message": "Calling 'next_entry_seek'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2692,
                    "column": 6,
                    "event": "note",
                    "message": "Calling 'next_cache_entry'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2736,
                    "column": 6,
                    "event": "note",
                    "message": "'file' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2736,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2741,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2745,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'file' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2745,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2765,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'cl_offset' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2765,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2815,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2815,
                    "column": 10,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 2819,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'read_children'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 966,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'entry_bytes_unconsumed' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 966,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 970,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'current_position' is <= field 'offset'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 970,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 978,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 978,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 984,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'current_position' is >= field 'offset'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 984,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 997,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'b' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1006,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1010,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1010,
                    "column": 10,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1010,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1010,
                    "column": 10,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1010,
                    "column": 47,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1010,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1020,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1021,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1025,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1028,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'child' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1028,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1032,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming field 'cl_offset' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1032,
                    "column": 30,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 1065,
                    "column": 9,
                    "event": "note",
                    "message": "Calling 'heap_add_entry'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 443,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'add_entry'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3019,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'used' is >= field 'allocated'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3019,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3023,
                    "column": 13,
                    "event": "note",
                    "message": "Field 'allocated' is < 1024",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3023,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3026,
                    "column": 7,
                    "event": "note",
                    "message": "'new_size' is > field 'allocated'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3026,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3032,
                    "column": 7,
                    "event": "note",
                    "message": "Storing uninitialized value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3033,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'new_pending_files' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3033,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'allocated' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3038,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3052,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3053,
                    "column": 3,
                    "event": "note",
                    "message": "The value 0 is assigned to 'parent'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_iso9660.c",
                    "line": 3054,
                    "column": 16,
                    "event": "note",
                    "message": "Access to field 'key' results in a dereference of an undefined pointer value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3052|   \twhile (hole > 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3053|   \t\tparent = (hole - 1)/2;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3054|-> \t\tparent_key = heap->files[parent]->key;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3055|   \t\tif (file_key >= parent_key) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3056|   \t\t\theap->files[hole] = file;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 758,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 699,
                    "event": "warning[objectIndex]",
                    "message": "The address of local variable 'window' might be accessed at non-zero index.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  697|       else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  698|         for (li = 0; li < l; li++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  699|->         d[li] = s[li];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  700|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  701|       remaining -= l;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'read_header'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1683,
                    "column": 3,
                    "event": "warning[-Wanalyzer-null-argument]",
                    "message": "use of NULL where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3767,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'rar_decode_byte'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3771,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 475,
                    "column": 28,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3771,
                    "column": 8,
                    "event": "note",
                    "message": "in expansion of macro 'rar_br_read_ahead'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 475,
                    "column": 28,
                    "event": "note",
                    "message": "(4) calling 'rar_br_fillup' from 'rar_decode_byte'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3771,
                    "column": 8,
                    "event": "note",
                    "message": "in expansion of macro 'rar_br_read_ahead'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 500,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'rar_br_fillup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 506,
                    "column": 5,
                    "event": "note",
                    "message": "(6) following 'default:' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 570,
                    "column": 11,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 570,
                    "column": 8,
                    "event": "note",
                    "message": "(8) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 572,
                    "column": 14,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 578,
                    "column": 21,
                    "event": "note",
                    "message": "(10) calling 'rar_read_ahead' from 'rar_br_fillup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3133,
                    "column": 1,
                    "event": "note",
                    "message": "(11) entry to 'rar_read_ahead'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3138,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following 'true' branch (when 'avail' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3140,
                    "column": 19,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3144,
                    "column": 8,
                    "event": "note",
                    "message": "(14) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3146,
                    "column": 13,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3146,
                    "column": 13,
                    "event": "note",
                    "message": "(16) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3149,
                    "column": 32,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3150,
                    "column": 13,
                    "event": "note",
                    "message": "(18) calling 'archive_read_format_rar_read_header' from 'rar_read_ahead'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 907,
                    "column": 1,
                    "event": "note",
                    "message": "(19) entry to 'archive_read_format_rar_read_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 939,
                    "column": 6,
                    "event": "note",
                    "message": "(20) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 943,
                    "column": 10,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 956,
                    "column": 8,
                    "event": "note",
                    "message": "(22) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 960,
                    "column": 15,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1020,
                    "column": 14,
                    "event": "note",
                    "message": "(24) calling 'read_header' from 'archive_read_format_rar_read_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1358,
                    "column": 1,
                    "event": "note",
                    "message": "(25) entry to 'read_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1392,
                    "column": 6,
                    "event": "note",
                    "message": "(26) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1395,
                    "column": 3,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1398,
                    "column": 6,
                    "event": "note",
                    "message": "(28) following 'false' branch (when 'header_size > 31')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1403,
                    "column": 15,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1406,
                    "column": 6,
                    "event": "note",
                    "message": "(30) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1408,
                    "column": 29,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1433,
                    "column": 6,
                    "event": "note",
                    "message": "(32) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1437,
                    "column": 15,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1438,
                    "column": 6,
                    "event": "note",
                    "message": "(34) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1447,
                    "column": 8,
                    "event": "note",
                    "message": "(35) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1487,
                    "column": 6,
                    "event": "note",
                    "message": "(36) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1494,
                    "column": 24,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1499,
                    "column": 6,
                    "event": "note",
                    "message": "(38) following 'false' branch (when 'head_type != 122')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1510,
                    "column": 19,
                    "event": "note",
                    "message": "(39) inlined call to 'archive_le16dec' from 'read_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_endian.h",
                    "line": 110,
                    "column": 21,
                    "event": "note",
                    "message": "(40) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'read_header'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1511,
                    "column": 6,
                    "event": "note",
                    "message": "(41) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1516,
                    "column": 10,
                    "event": "note",
                    "message": "(42) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1641,
                    "column": 20,
                    "event": "note",
                    "message": "(43) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1641,
                    "column": 44,
                    "event": "note",
                    "message": "(44) following 'false' branch (when 'strp' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1647,
                    "column": 10,
                    "event": "note",
                    "message": "(45) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1674,
                    "column": 11,
                    "event": "note",
                    "message": "(46) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1682,
                    "column": 53,
                    "event": "note",
                    "message": "(47) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1681,
                    "column": 31,
                    "event": "note",
                    "message": "(48) when 'realloc' fails",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1681,
                    "column": 22,
                    "event": "note",
                    "message": "(49) '0' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 1683,
                    "column": 3,
                    "event": "note",
                    "message": "(50) argument 1 ('realloc(*rar.filename_save, (long unsigned int)(filename_size + 1))') NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<built-in>",
                    "line": 0,
                    "event": "note",
                    "message": "argument 1 of '__builtin_memcpy' must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1681|     rar->filename_save = (char*)realloc(rar->filename_save,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1682|                                         filename_size + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1683|->   memcpy(rar->filename_save, rar->filename, filename_size + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1684|     rar->filename_save_size = filename_size;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1685|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3210,
                    "column": 12,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'next' results in a dereference of a null pointer (loaded from variable 'prog')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2843,
                    "column": 34,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 162,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'minimum'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2864,
                    "column": 34,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 162,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'minimum'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2878,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2878,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2881,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2883,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2883,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2887,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming field 'is_ppmd_block' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2887,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2892,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2892,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2895,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'symbol' is >= 256",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2895,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2900,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'symbol' is not equal to 256",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2900,
                    "column": 10,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2924,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'symbol' is equal to 257",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2924,
                    "column": 10,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2926,
                    "column": 12,
                    "event": "note",
                    "message": "Calling 'read_filter'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3542,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3545,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'length' is not equal to 7",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3545,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3551,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'length' is not equal to 8",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3551,
                    "column": 8,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3562,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'code' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3562,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3564,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'length'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3564,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 3572",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3572,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'parse_filter'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3185,
                    "column": 31,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3185,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 3188",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3188,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3188,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3208,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'prog'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3209,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'i' is < 'num'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3209,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3210,
                    "column": 12,
                    "event": "note",
                    "message": "Access to field 'next' results in a dereference of a null pointer (loaded from variable 'prog')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3208|     prog = filters->progs;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3209|     for (i = 0; i < num; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3210|->     prog = prog->next;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3211|     if (prog)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3212|       prog->usagecount++;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3315,
                    "event": "error[memleak]",
                    "message": "Memory leak: filter",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3313|     filter->globaldata = calloc(1, filter->globaldatalen);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3314|     if (!filter->globaldata)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3315|->     return NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3316|     if (globaldata)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3317|       memcpy(filter->globaldata, globaldata, globaldatalen);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3315,
                    "column": 12,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'filter'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/lib/clang/18/include/__stddef_null.h",
                    "line": 26,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'NULL'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2843,
                    "column": 34,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 162,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'minimum'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2864,
                    "column": 34,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 162,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'minimum'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2878,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2878,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2881,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2883,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2883,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2887,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming field 'is_ppmd_block' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2887,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2892,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2892,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2895,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'symbol' is >= 256",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2895,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2900,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'symbol' is not equal to 256",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2900,
                    "column": 10,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2924,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'symbol' is equal to 257",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2924,
                    "column": 10,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 2926,
                    "column": 12,
                    "event": "note",
                    "message": "Calling 'read_filter'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3542,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3545,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'length' is not equal to 7",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3545,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3551,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'length' is not equal to 8",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3551,
                    "column": 8,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3562,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'code' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3562,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3564,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'length'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3564,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 3572",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3572,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'parse_filter'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3185,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 3188",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3188,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3188,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3209,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3209,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 3211",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3211,
                    "column": 7,
                    "event": "note",
                    "message": "'prog' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3211,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3215,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3215,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3217,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3217,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3220,
                    "column": 19,
                    "event": "note",
                    "message": "'prog' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3220,
                    "column": 19,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3224,
                    "column": 18,
                    "event": "note",
                    "message": "'prog' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3224,
                    "column": 18,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3227,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3227,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3235,
                    "column": 8,
                    "event": "note",
                    "message": "'prog' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3235,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3241,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'len' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3241,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3241,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'len' is <= 65536",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3241,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3244,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'bytecode' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3244,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3246,
                    "column": 17,
                    "event": "note",
                    "message": "'i' is < 'len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3246,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3246,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3246,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 3248",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3249,
                    "column": 10,
                    "event": "note",
                    "message": "'prog' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3249,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3255,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 3257",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3263,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3263,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3275,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'at_eof' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3275,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3281,
                    "column": 12,
                    "event": "note",
                    "message": "Calling 'create_filter'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3308,
                    "column": 12,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3309,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'filter' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3309,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3312,
                    "column": 27,
                    "event": "note",
                    "message": "'globaldatalen' is <= PROGRAM_SYSTEM_GLOBAL_SIZE",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3312,
                    "column": 27,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3314,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'globaldata' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3314,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar.c",
                    "line": 3315,
                    "column": 12,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'filter'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib/clang/18/include/__stddef_null.h",
                    "line": 26,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'NULL'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3313|     filter->globaldata = calloc(1, filter->globaldatalen);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3314|     if (!filter->globaldata)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3315|->     return NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3316|     if (globaldata)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3317|       memcpy(filter->globaldata, globaldata, globaldatalen);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 391,
                    "column": 11,
                    "event": "warning[unix.MallocSizeof]",
                    "message": "Result of 'malloc' is converted to a pointer of type 'size_t', which is incompatible with sizeof operand type 'void *'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 391,
                    "column": 11,
                    "event": "note",
                    "message": "Result of 'malloc' is converted to a pointer of type 'size_t', which is incompatible with sizeof operand type 'void *'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  389|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  390|   \tcdeque_clear(d);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  391|-> \td->arr = malloc(sizeof(void*) * max_capacity_power_of_2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  392|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  393|   \treturn d->arr ? CDE_OK : CDE_ALLOC;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2951,
                    "column": 9,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'filt'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive.h",
                    "line": 194,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'ARCHIVE_OK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2898,
                    "column": 5,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive.h",
                    "line": 194,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'ARCHIVE_OK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2898,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2901,
                    "column": 5,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive.h",
                    "line": 194,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'ARCHIVE_OK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2901,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2904,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2914,
                    "column": 5,
                    "event": "note",
                    "message": "Assuming 'block_length' is >= 4",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2914,
                    "column": 5,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2915,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'block_length' is <= 4194304",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2914,
                    "column": 5,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2916,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'filter_type' is <= FILTER_ARM",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2914,
                    "column": 5,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2914,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2925,
                    "column": 9,
                    "event": "note",
                    "message": "Calling 'add_new_filter'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 533,
                    "column": 25,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 535,
                    "column": 5,
                    "event": "note",
                    "message": "Assuming 'f' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 535,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2925,
                    "column": 9,
                    "event": "note",
                    "message": "Returned allocated memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2926,
                    "column": 5,
                    "event": "note",
                    "message": "'filt' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2926,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2942,
                    "column": 5,
                    "event": "note",
                    "message": "Assuming 'filter_type' is not equal to FILTER_DELTA",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2942,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_read_support_format_rar5.c",
                    "line": 2951,
                    "column": 9,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'filt'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive.h",
                    "line": 194,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'ARCHIVE_OK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2949|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2950|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2951|-> \treturn ARCHIVE_OK;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2952|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2953|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 12316 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 12317 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 465,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_string_append'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 206,
                    "column": 12,
                    "event": "warning[-Wanalyzer-deref-before-check]",
                    "message": "check of 'as' for NULL after already dereferencing it",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2229,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'best_effort_strncat_in_locale.part.0'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2255,
                    "column": 21,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2256,
                    "column": 26,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2256,
                    "column": 20,
                    "event": "note",
                    "message": "(4) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2258,
                    "column": 31,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2258,
                    "column": 28,
                    "event": "note",
                    "message": "(6) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2259,
                    "column": 37,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 2259,
                    "column": 37,
                    "event": "note",
                    "message": "(8) calling 'archive_string_append' from 'best_effort_strncat_in_locale.part.0'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 204,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'archive_string_append'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 206,
                    "column": 41,
                    "event": "note",
                    "message": "(10) pointer 'as' is dereferenced here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_string.c",
                    "line": 206,
                    "column": 12,
                    "event": "note",
                    "message": "(11) pointer 'as' is checked for NULL here but it was already dereferenced at (10)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  204|   archive_string_append(struct archive_string *as, const char *p, size_t s)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  205|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  206|-> \tif (archive_string_ensure(as, as->length + s + 1) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  207|   \t\treturn (NULL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  208|   \tif (s)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_utility_string_sort_helper'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "warning[-Wanalyzer-double-free]",
                    "message": "double-'free' of 'lesser'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'n > 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 648,
                    "column": 15,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 666,
                    "column": 38,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 667,
                    "column": 40,
                    "event": "note",
                    "message": "(7) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 669,
                    "column": 28,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 675,
                    "column": 47,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 653,
                    "column": 37,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "note",
                    "message": "(14) second 'free' here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  652|   \t\t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  653|   \t\t\tlesser_count++;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  654|-> \t\t\ttmp = (char **)realloc(lesser,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  655|   \t\t\t\tlesser_count * sizeof(char *));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  656|   \t\t\tif (!tmp) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 657,
                    "column": 33,
                    "event": "warning[-Wanalyzer-double-free]",
                    "message": "double-'free' of 'greater'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'n > 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 648,
                    "column": 15,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(5) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 653,
                    "column": 37,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "note",
                    "message": "(7) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 656,
                    "column": 28,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 662,
                    "column": 45,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 653,
                    "column": 37,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "note",
                    "message": "(14) when 'realloc' fails",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 656,
                    "column": 28,
                    "event": "note",
                    "message": "(15) following 'true' branch (when 'tmp' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 657,
                    "column": 33,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 657,
                    "column": 33,
                    "event": "note",
                    "message": "(17) second 'free' here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  655|   \t\t\t\tlesser_count * sizeof(char *));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  656|   \t\t\tif (!tmp) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  657|-> \t\t\t\tfree(greater);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  658|   \t\t\t\tfree(lesser);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  659|   \t\t\t\treturn (ARCHIVE_FATAL);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 667,
                    "column": 40,
                    "event": "warning[-Wanalyzer-double-free]",
                    "message": "double-'free' of 'greater'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'n > 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 648,
                    "column": 15,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(5) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 653,
                    "column": 37,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "note",
                    "message": "(7) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 656,
                    "column": 28,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 662,
                    "column": 45,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(12) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 666,
                    "column": 38,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 667,
                    "column": 40,
                    "event": "note",
                    "message": "(14) second 'free' here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  665|   \t\t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  666|   \t\t\tgreater_count++;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  667|-> \t\t\ttmp = (char **)realloc(greater,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  668|   \t\t\t\tgreater_count * sizeof(char *));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  669|   \t\t\tif (!tmp) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 671,
                    "column": 33,
                    "event": "warning[-Wanalyzer-double-free]",
                    "message": "double-'free' of 'lesser'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'n > 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 648,
                    "column": 15,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 666,
                    "column": 38,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 667,
                    "column": 40,
                    "event": "note",
                    "message": "(7) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 669,
                    "column": 28,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 675,
                    "column": 47,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(12) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 666,
                    "column": 38,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 667,
                    "column": 40,
                    "event": "note",
                    "message": "(14) when 'realloc' fails",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 669,
                    "column": 28,
                    "event": "note",
                    "message": "(15) following 'true' branch (when 'tmp' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 670,
                    "column": 33,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 671,
                    "column": 33,
                    "event": "note",
                    "message": "(17) second 'free' here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  669|   \t\t\tif (!tmp) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  670|   \t\t\t\tfree(greater);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  671|-> \t\t\t\tfree(lesser);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  672|   \t\t\t\treturn (ARCHIVE_FATAL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  673|   \t\t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 683,
                    "column": 9,
                    "event": "warning[-Wanalyzer-double-free]",
                    "message": "double-'free' of 'lesser'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 636,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'n > 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 648,
                    "column": 15,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 666,
                    "column": 38,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 667,
                    "column": 40,
                    "event": "note",
                    "message": "(8) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 669,
                    "column": 28,
                    "event": "note",
                    "message": "(9) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 675,
                    "column": 47,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(11) following 'false' branch (when 'i >= n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(13) passing freed pointer 'lesser' in call to 'archive_utility_string_sort_helper' from 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 636,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following 'true' branch (when 'n <= 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(17) returning to 'archive_utility_string_sort_helper' from 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 681,
                    "column": 23,
                    "event": "note",
                    "message": "(18) following 'false' branch (when 'i >= lesser_count')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 683,
                    "column": 9,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 683,
                    "column": 9,
                    "event": "note",
                    "message": "(20) second 'free' here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  681|   \tfor (i = 0; i < lesser_count; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  682|   \t\tstrings[i] = lesser[i];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  683|-> \tfree(lesser);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  684|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  685|   \t/* pivot */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 692,
                    "column": 9,
                    "event": "warning[-Wanalyzer-double-free]",
                    "message": "double-'free' of 'greater'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 636,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'n > 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 648,
                    "column": 15,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(6) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 653,
                    "column": 37,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "note",
                    "message": "(8) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 656,
                    "column": 28,
                    "event": "note",
                    "message": "(9) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 662,
                    "column": 45,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(11) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 653,
                    "column": 37,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "note",
                    "message": "(15) when 'realloc' succeeds, without moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 656,
                    "column": 28,
                    "event": "note",
                    "message": "(16) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 662,
                    "column": 45,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(18) following 'false' branch (when 'i >= n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(20) calling 'archive_utility_string_sort_helper' from 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 636,
                    "column": 1,
                    "event": "note",
                    "message": "(21) entry to 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(22) following 'false' branch (when 'n > 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 648,
                    "column": 15,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(24) following 'true' branch (when 'i < n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 35,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 651,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 653,
                    "column": 37,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 654,
                    "column": 40,
                    "event": "note",
                    "message": "(28) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 656,
                    "column": 28,
                    "event": "note",
                    "message": "(29) following 'false' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 662,
                    "column": 45,
                    "event": "note",
                    "message": "(30) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 649,
                    "column": 23,
                    "event": "note",
                    "message": "(31) following 'false' branch (when 'i >= n')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(32) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(33) calling 'archive_utility_string_sort_helper' from 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 636,
                    "column": 1,
                    "event": "note",
                    "message": "(34) entry to 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(35) following 'true' branch (when 'n <= 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 680,
                    "column": 19,
                    "event": "note",
                    "message": "(37) returning to 'archive_utility_string_sort_helper' from 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 681,
                    "column": 23,
                    "event": "note",
                    "message": "(38) following 'true' branch (when 'i < lesser_count')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 682,
                    "column": 36,
                    "event": "note",
                    "message": "(39) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 689,
                    "column": 19,
                    "event": "note",
                    "message": "(40) passing freed pointer 'greater' in call to 'archive_utility_string_sort_helper' from 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 636,
                    "column": 1,
                    "event": "note",
                    "message": "(41) entry to 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 643,
                    "column": 12,
                    "event": "note",
                    "message": "(42) following 'true' branch (when 'n <= 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(43) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 689,
                    "column": 19,
                    "event": "note",
                    "message": "(44) returning to 'archive_utility_string_sort_helper' from 'archive_utility_string_sort_helper'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 690,
                    "column": 23,
                    "event": "note",
                    "message": "(45) following 'false' branch (when 'i >= greater_count')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 692,
                    "column": 9,
                    "event": "note",
                    "message": "(46) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_util.c",
                    "line": 692,
                    "column": 9,
                    "event": "note",
                    "message": "(47) second 'free' here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  690|   \tfor (i = 0; i < greater_count; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  691|   \t\tstrings[lesser_count + 1 + i] = greater[i];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  692|-> \tfree(greater);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  693|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  694|   \treturn (retval1 < retval2) ? retval1 : retval2;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_write_new'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 124,
                    "column": 17,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'a'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 102,
                    "column": 37,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 103,
                    "column": 12,
                    "event": "note",
                    "message": "(2) assuming 'a' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 103,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following 'false' branch (when 'a' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 105,
                    "column": 26,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 119,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following 'false' branch (when 'nulls' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 123,
                    "column": 18,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write.c",
                    "line": 124,
                    "column": 17,
                    "event": "note",
                    "message": "(7) 'a' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  122|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  123|   \ta->nulls = nulls;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  124|-> \treturn (&a->archive);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  125|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  126|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_bzip2.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_compressor_bzip2_open'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_bzip2.c",
                    "line": 184,
                    "column": 20,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'malloc(bs)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_bzip2.c",
                    "line": 170,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_bzip2.c",
                    "line": 172,
                    "column": 22,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_bzip2.c",
                    "line": 183,
                    "column": 31,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_bzip2.c",
                    "line": 184,
                    "column": 20,
                    "event": "note",
                    "message": "(4) 'malloc(bs)' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  182|   \t\tdata->compressed",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  183|   \t\t    = (char *)malloc(data->compressed_buffer_size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  184|-> \t\tif (data->compressed == NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  185|   \t\t\tarchive_set_error(f->archive, ENOMEM,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  186|   \t\t\t    \"Can't allocate data for compression buffer\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_gzip.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_compressor_gzip_open'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_gzip.c",
                    "line": 201,
                    "column": 20,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'malloc(bs)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_gzip.c",
                    "line": 187,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_gzip.c",
                    "line": 189,
                    "column": 22,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_gzip.c",
                    "line": 200,
                    "column": 40,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_gzip.c",
                    "line": 201,
                    "column": 20,
                    "event": "note",
                    "message": "(4) 'malloc(bs)' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  199|   \t\tdata->compressed",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  200|   \t\t    = (unsigned char *)malloc(data->compressed_buffer_size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  201|-> \t\tif (data->compressed == NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  202|   \t\t\tarchive_set_error(f->archive, ENOMEM,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  203|   \t\t\t    \"Can't allocate data for compression buffer\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_xz.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_compressor_xz_open'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_xz.c",
                    "line": 326,
                    "column": 20,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'malloc(bs)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_xz.c",
                    "line": 312,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_xz.c",
                    "line": 314,
                    "column": 22,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_xz.c",
                    "line": 325,
                    "column": 40,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_xz.c",
                    "line": 326,
                    "column": 20,
                    "event": "note",
                    "message": "(4) 'malloc(bs)' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  324|   \t\tdata->compressed",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  325|   \t\t    = (unsigned char *)malloc(data->compressed_buffer_size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  326|-> \t\tif (data->compressed == NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  327|   \t\t\tarchive_set_error(f->archive, ENOMEM,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  328|   \t\t\t    \"Can't allocate data for compression buffer\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_zstd.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_compressor_zstd_open'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_zstd.c",
                    "line": 314,
                    "column": 20,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'malloc(bs)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_zstd.c",
                    "line": 299,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_zstd.c",
                    "line": 300,
                    "column": 29,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_zstd.c",
                    "line": 313,
                    "column": 40,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_add_filter_zstd.c",
                    "line": 314,
                    "column": 20,
                    "event": "note",
                    "message": "(4) 'malloc(bs)' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  312|   \t\tdata->out.dst",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  313|   \t\t    = (unsigned char *)malloc(data->out.size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|-> \t\tif (data->out.dst == NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|   \t\t\tarchive_set_error(f->archive, ENOMEM,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  316|   \t\t\t    \"Can't allocate data for compression buffer\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_file.c",
                    "line": 92,
                    "column": 8,
                    "event": "warning[unix.Errno]",
                    "message": "An undefined value may be read from 'errno'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/include/errno.h",
                    "line": 38,
                    "column": 16,
                    "event": "note",
                    "message": "expanded from macro 'errno'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_file.c",
                    "line": 89,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_file.c",
                    "line": 90,
                    "column": 18,
                    "event": "note",
                    "message": "Assuming that 'fwrite' is successful; 'errno' becomes undefined after the call",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_file.c",
                    "line": 91,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bytesWritten' is <= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_file.c",
                    "line": 91,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_file.c",
                    "line": 92,
                    "column": 8,
                    "event": "note",
                    "message": "An undefined value may be read from 'errno'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/errno.h",
                    "line": 38,
                    "column": 16,
                    "event": "note",
                    "message": "expanded from macro 'errno'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   90|   \t\tbytesWritten = fwrite(buff, 1, length, mine->f);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   91|   \t\tif (bytesWritten <= 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   92|-> \t\t\tif (errno == EINTR)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   93|   \t\t\t\tcontinue;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|   \t\t\tarchive_set_error(a, errno, \"Write error\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_filename.c",
                    "line": 114,
                    "event": "error[memleak]",
                    "message": "Memory leak: mine",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  112|   \t\tif (errno == ENOMEM) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  113|   \t\t\tarchive_set_error(a, ENOMEM, \"No memory\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  114|-> \t\t\treturn (ARCHIVE_FATAL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  115|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  116|   \t\tif (mbs_fn)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_open_filename.c",
                    "line": 124,
                    "event": "error[memleak]",
                    "message": "Memory leak: mine",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  122|   \t\t\t    \"Can't convert '%S' to MBS\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  123|   \t\t\t    (const wchar_t *)filename);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  124|-> \t\treturn (ARCHIVE_FAILED);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  125|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  126|   \tmine->fd = -1;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 835,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'compress_out'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 593,
                    "column": 21,
                    "event": "warning[-Wanalyzer-infinite-loop]",
                    "message": "infinite loop",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 1272,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'make_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 880,
                    "column": 1,
                    "event": "note",
                    "message": "(2) entry to 'enc_uint64'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 577,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'compress_out'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 593,
                    "column": 21,
                    "event": "note",
                    "message": "(4) infinite loop here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 593,
                    "column": 21,
                    "event": "note",
                    "message": "(5) inlined call to 'compression_code' from 'compress_out'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 2330,
                    "column": 12,
                    "event": "note",
                    "message": "(6) if it ever follows 'false' branch, it will always do so...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'compress_out'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 596,
                    "column": 32,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 596,
                    "column": 20,
                    "event": "note",
                    "message": "(8) if it ever follows 'false' branch, it will always do so...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 608,
                    "column": 32,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 608,
                    "column": 20,
                    "event": "note",
                    "message": "(10) if it ever follows 'false' branch, it will always do so...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) looping back...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_7zip.c",
                    "line": 593,
                    "column": 21,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  591|   \tfor (;;) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  592|   \t\t/* Compress file data. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  593|-> \t\tr = compression_code(&(a->archive), &(zip->stream), run);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  594|   \t\tif (r != ARCHIVE_OK && r != ARCHIVE_EOF)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  595|   \t\t\treturn (ARCHIVE_FATAL);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'synthesize_ino_value'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 325,
                    "column": 9,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'newlist'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 380,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'write_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 432,
                    "column": 15,
                    "event": "note",
                    "message": "(2) calling 'synthesize_ino_value' from 'write_header'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 279,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'synthesize_ino_value'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 291,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 295,
                    "column": 13,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 295,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 310,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 312,
                    "column": 27,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 313,
                    "column": 33,
                    "event": "note",
                    "message": "(10) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 313,
                    "column": 33,
                    "event": "note",
                    "message": "(11) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 315,
                    "column": 20,
                    "event": "note",
                    "message": "(12) following 'false' branch (when 'newlist' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 318,
                    "column": 37,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_cpio_binary.c",
                    "line": 325,
                    "column": 9,
                    "event": "note",
                    "message": "(14) 'newlist' leaks here; was allocated at (10)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  323|   \tcpio->ino_list[cpio->ino_list_next].old = ino;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  324|   \tcpio->ino_list[cpio->ino_list_next].new = ino_new;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  325|-> \t++cpio->ino_list_next;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  326|   \treturn (ino_new);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  327|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'isoent_rr_move'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6791,
                    "column": 20,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL '0'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6984,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'isoent_make_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6995,
                    "column": 21,
                    "event": "note",
                    "message": "(2) calling 'isoent_alloc_path_table' from 'isoent_make_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6959,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'isoent_alloc_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6966,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6995,
                    "column": 21,
                    "event": "note",
                    "message": "(6) returning to 'isoent_make_path_table' from 'isoent_alloc_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7002,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following 'false' branch (when 'r == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7004,
                    "column": 13,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7004,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7014,
                    "column": 9,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7014,
                    "column": 9,
                    "event": "note",
                    "message": "(11) calling 'isoent_collect_dirs' from 'isoent_make_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6617,
                    "column": 1,
                    "event": "note",
                    "message": "(12) entry to 'isoent_collect_dirs'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6621,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following 'true' branch (when 'rootent' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6622,
                    "column": 25,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6626,
                    "column": 17,
                    "event": "note",
                    "message": "(15) inlined call to 'path_table_add_entry' from 'isoent_collect_dirs'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6887,
                    "column": 21,
                    "event": "note",
                    "message": "(16) '*rootent.ptnext' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6887,
                    "column": 21,
                    "event": "note",
                    "message": "(17) '*rootent.ptnext' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'isoent_rr_move'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7014,
                    "column": 9,
                    "event": "note",
                    "message": "(18) returning to 'isoent_make_path_table' from 'isoent_collect_dirs'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7020,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7021,
                    "column": 21,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7021,
                    "column": 21,
                    "event": "note",
                    "message": "(21) calling 'isoent_rr_move' from 'isoent_make_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6735,
                    "column": 1,
                    "event": "note",
                    "message": "(22) entry to 'isoent_rr_move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6745,
                    "column": 12,
                    "event": "note",
                    "message": "(23) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6748,
                    "column": 17,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6752,
                    "column": 12,
                    "event": "note",
                    "message": "(25) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6753,
                    "column": 42,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6752,
                    "column": 30,
                    "event": "note",
                    "message": "(27) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6759,
                    "column": 17,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6762,
                    "column": 17,
                    "event": "note",
                    "message": "(29) calling 'isoent_add_child_head' from 'isoent_rr_move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 5234,
                    "column": 1,
                    "event": "note",
                    "message": "(30) entry to 'isoent_add_child_head'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 5237,
                    "column": 12,
                    "event": "note",
                    "message": "(31) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(32) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(33) calling 'isoent_add_child_head.part.0' from 'isoent_add_child_head'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 5234,
                    "column": 1,
                    "event": "note",
                    "message": "(34) entry to 'isoent_add_child_head.part.0'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 5247,
                    "column": 12,
                    "event": "note",
                    "message": "(35) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 5254,
                    "column": 31,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 5254,
                    "column": 31,
                    "event": "note",
                    "message": "(37) '*child.drnext' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(38) returning to 'isoent_add_child_head' from 'isoent_add_child_head.part.0'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6762,
                    "column": 17,
                    "event": "note",
                    "message": "(39) returning to 'isoent_rr_move' from 'isoent_add_child_head'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6770,
                    "column": 19,
                    "event": "note",
                    "message": "(40) following 'true' branch (when 'np' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6771,
                    "column": 24,
                    "event": "note",
                    "message": "(41) inlined call to 'path_table_last_entry' from 'isoent_rr_move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6896,
                    "column": 20,
                    "event": "note",
                    "message": "(42) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'isoent_rr_move'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6791,
                    "column": 20,
                    "event": "note",
                    "message": "(43) dereference of NULL '<unknown>'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6789|   \t\t * its sub directory entries move to rr_move too.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6790|   \t\t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6791|-> \t\tnp = last->ptnext;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6792|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6793|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6888,
                    "column": 17,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of undefined pointer value (loaded from field 'last')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 1862,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'wbuff_remaining' is <= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 794,
                    "column": 25,
                    "event": "note",
                    "message": "expanded from macro 'wb_remaining'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 1862,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 1879,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'boot' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 1879,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 1904,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'joliet' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 1904,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 1932,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'isoent_make_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6993,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'dircnt_max' is >= MAX_DEPTH",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6993,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6994,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'limit_depth' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6994,
                    "column": 33,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6995,
                    "column": 7,
                    "event": "note",
                    "message": "Calling 'isoent_alloc_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6965,
                    "column": 17,
                    "event": "note",
                    "message": "Uninitialized value stored to field 'last'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6966,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'pathtbl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6966,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6971,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= field 'max_depth'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6971,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 6977",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6995,
                    "column": 7,
                    "event": "note",
                    "message": "Returning from 'isoent_alloc_path_table'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7002,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7002,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7004,
                    "column": 19,
                    "event": "note",
                    "message": "Field 'joliet' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7004,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 7014,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'isoent_collect_dirs'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6621,
                    "column": 6,
                    "event": "note",
                    "message": "'rootent' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6621,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6626,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'path_table_add_entry'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_iso9660.c",
                    "line": 6888,
                    "column": 17,
                    "event": "note",
                    "message": "Dereference of undefined pointer value (loaded from field 'last')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6886|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6887|   \tent->ptnext = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6888|-> \t*pathtbl->last = ent;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6889|   \tpathtbl->last = &(ent->ptnext);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 6890|   \tpathtbl->cnt ++;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'mtree_entry_tree_add'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2152,
                    "column": 27,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL 'dent'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 1987,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'mtree_entry_tree_add'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2014,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2022,
                    "column": 16,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2048,
                    "column": 21,
                    "event": "note",
                    "message": "(4) calling 'get_path_component' from 'mtree_entry_tree_add'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 1964,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'get_path_component'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 1969,
                    "column": 13,
                    "event": "note",
                    "message": "(6) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 1970,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following 'true' branch (when 'p' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 1971,
                    "column": 26,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2048,
                    "column": 21,
                    "event": "note",
                    "message": "(9) returning to 'mtree_entry_tree_add' from 'get_path_component'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2049,
                    "column": 20,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2053,
                    "column": 20,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2053,
                    "column": 20,
                    "event": "note",
                    "message": "(12) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2059,
                    "column": 20,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2085,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following 'true' branch (when 'np' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2089,
                    "column": 30,
                    "event": "note",
                    "message": "(16) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2132,
                    "column": 35,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2132,
                    "column": 35,
                    "event": "note",
                    "message": "(18) 'dent' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_mtree.c",
                    "line": 2152,
                    "column": 27,
                    "event": "note",
                    "message": "(19) dereference of NULL 'dent'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2150|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2151|   \t\tif (!__archive_rb_tree_insert_node(",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2152|-> \t\t    &(dent->dir_info->rbtree),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2153|   \t\t    (struct archive_rb_node *)file)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2154|   \t\t\tnp = (struct mtree_entry *)__archive_rb_tree_find_node(",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'archive_write_shar_header'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 213,
                    "column": 22,
                    "event": "warning[-Wanalyzer-possible-null-argument]",
                    "message": "use of possibly-NULL 'p' where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 210,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 212,
                    "column": 21,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 212,
                    "column": 21,
                    "event": "note",
                    "message": "(3) this call could return NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 213,
                    "column": 22,
                    "event": "note",
                    "message": "(4) argument 1 ('p') from (3) could be NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 38,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/string.h",
                    "line": 273,
                    "column": 14,
                    "event": "note",
                    "message": "argument 1 of 'strrchr' must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  211|   \t\t/* Try to create the dir. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|   \t\tp = strdup(name);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  213|-> \t\tpp = strrchr(p, '/');",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  214|   \t\t/* If there is a / character, try to create the dir. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   \t\tif (pp != NULL) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 296,
                    "column": 30,
                    "event": "warning[-Wanalyzer-possible-null-argument]",
                    "message": "use of possibly-NULL 'strdup(archive_entry_pathname(entry))' where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 249,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 254,
                    "column": 32,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 254,
                    "column": 19,
                    "event": "note",
                    "message": "(3) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 260,
                    "column": 24,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 260,
                    "column": 17,
                    "event": "note",
                    "message": "(5) following 'case 16384:' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 287,
                    "column": 17,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 294,
                    "column": 42,
                    "event": "note",
                    "message": "(7) this call could return NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/archive_write_set_format_shar.c",
                    "line": 296,
                    "column": 30,
                    "event": "note",
                    "message": "(8) argument 1 ('strdup(archive_entry_pathname(entry))') from (7) could be NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/string.h",
                    "line": 273,
                    "column": 14,
                    "event": "note",
                    "message": "argument 1 of 'strrchr' must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  294|   \t\t\tshar->last_dir = strdup(name);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  295|   \t\t\t/* Trim a trailing '/'. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  296|-> \t\t\tpp = strrchr(shar->last_dir, '/');",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  297|   \t\t\tif (pp != NULL && pp[1] == '\\0')",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  298|   \t\t\t\t*pp = '\\0';",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive/xxhash.c",
                    "line": 350,
                    "column": 17,
                    "event": "warning[-Wanalyzer-possible-null-dereference]",
                    "message": "dereference of possibly-NULL 'state'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/xxhash.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'XXH32_init'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/xxhash.c",
                    "line": 91,
                    "column": 20,
                    "event": "note",
                    "message": "(1) this call could return NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/xxhash.c",
                    "line": 363,
                    "column": 19,
                    "event": "note",
                    "message": "in expansion of macro 'XXH_malloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/xxhash.c",
                    "line": 364,
                    "column": 5,
                    "event": "note",
                    "message": "(2) inlined call to 'XXH32_resetState' from 'XXH32_init'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive/xxhash.c",
                    "line": 350,
                    "column": 17,
                    "event": "note",
                    "message": "(3) 'state' could be NULL: unchecked value from (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  348|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  349|       struct XXH_state32_t * state = (struct XXH_state32_t *) state_in;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  350|->     state->seed = seed;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  351|       state->v1 = seed + PRIME32_1 + PRIME32_2;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  352|       state->v2 = seed + PRIME32_2;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/line_reader.c",
                    "line": 79,
                    "event": "error[memleak]",
                    "message": "Memory leak: lr.f",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   77|   \tlr->line_start = lr->line_end = lr->buff_end = lr->buff = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   78|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   79|-> \treturn (lr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   80|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   81|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/line_reader.c",
                    "line": 79,
                    "event": "error[memleak]",
                    "message": "Memory leak: lr.pathname",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   77|   \tlr->line_start = lr->line_end = lr->buff_end = lr->buff = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   78|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   79|-> \treturn (lr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   80|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   81|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 188,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'nr' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 188,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'nr' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  186|   \tfor (i = 0; i <= MAX_SIGNO; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  187|   \t\tsigno[i] = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|-> \tnr = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  189|   \tsave_errno = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  190|   \tneed_restart = 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 189,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'save_errno' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 189,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'save_errno' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  187|   \t\tsigno[i] = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|   \tnr = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  189|-> \tsave_errno = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  190|   \tneed_restart = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  191|   \t/*",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'readpassphrase'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 210,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor 'open(\"/dev/tty\", 2)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 180,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'bufsiz != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 186,
                    "column": 23,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'i != 23')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 187,
                    "column": 26,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 195,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 196,
                    "column": 31,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 196,
                    "column": 31,
                    "event": "note",
                    "message": "(7) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 195,
                    "column": 33,
                    "event": "note",
                    "message": "(8) assuming 'open(\"/dev/tty\", 2)' is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 195,
                    "column": 33,
                    "event": "note",
                    "message": "(9) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/libarchive_fe/passphrase.c",
                    "line": 210,
                    "column": 12,
                    "event": "note",
                    "message": "(10) ...to here (11) 'open(\"/dev/tty\", 2)' leaks here; was opened at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  208|   \t * generate SIGTTOU, so do it *before* installing the signal handlers.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  209|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  210|-> \tif (input != STDIN_FILENO && tcgetattr(input, &oterm) == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  211|   \t\tmemcpy(&term, &oterm, sizeof(term));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|   \t\tif (!(flags & RPP_ECHO_ON))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 562,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/tar/write.c",
                    "line": 359,
                    "event": "error[autoVariables]",
                    "message": "Address of local auto-variable assigned to a function parameter.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  357|   \tstruct archive_dir\t archive_dir;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  358|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  359|-> \tbsdtar->archive_dir = &archive_dir;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  360|   \tmemset(&archive_dir, 0, sizeof(archive_dir));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  361|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 263,
                    "column": 11,
                    "event": "warning[core.NullDereference]",
                    "message": "Array access (from variable 'str') results in a null pointer dereference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1215,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 18,
                    "event": "note",
                    "message": "'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 26,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1222",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'version_opt' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'argc' is > 'nopts'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'unzip_exclude_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1277",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1280,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'unzip'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'O_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'P_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1033,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ret' is not equal to ARCHIVE_EOF",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 't_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'v_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'p_opt' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1044,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'extract_stdout'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 857,
                    "column": 18,
                    "event": "note",
                    "message": "Calling 'pathdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'path' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 22,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'len' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 255,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 255,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 257",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 7,
                    "event": "note",
                    "message": "Value assigned to 'str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 261,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'L_opt' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 261,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 262,
                    "column": 15,
                    "event": "note",
                    "message": "'i' is < 'len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 262,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 263,
                    "column": 13,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/ctype.h",
                    "line": 220,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'tolower'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/ctype.h",
                    "line": 158,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro '__tobody'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 263,
                    "column": 11,
                    "event": "note",
                    "message": "Array access (from variable 'str') results in a null pointer dereference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  261|   \tif (L_opt) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  262|   \t\tfor (i = 0; i < len; ++i)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|-> \t\t\tstr[i] = tolower((unsigned char)path[i]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   \t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  265|   \t\tmemcpy(str, path, len);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 265,
                    "column": 3,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1215,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 18,
                    "event": "note",
                    "message": "'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 26,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1222",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'version_opt' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'argc' is > 'nopts'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'unzip_exclude_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1277",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1280,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'unzip'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'O_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'P_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1033,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ret' is not equal to ARCHIVE_EOF",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 't_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'v_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'p_opt' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1044,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'extract_stdout'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 857,
                    "column": 18,
                    "event": "note",
                    "message": "Calling 'pathdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'path' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 22,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'len' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 255,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 7,
                    "event": "note",
                    "message": "Value assigned to 'str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 261,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'L_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 261,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 265,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|   \t\t\tstr[i] = tolower((unsigned char)path[i]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   \t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  265|-> \t\tmemcpy(str, path, len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  266|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  267|   \tstr[len] = '\\0';",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 267,
                    "column": 11,
                    "event": "warning[core.NullDereference]",
                    "message": "Array access (from variable 'str') results in a null pointer dereference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1215,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 18,
                    "event": "note",
                    "message": "'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 26,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1222",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'version_opt' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'argc' is > 'nopts'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'unzip_exclude_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1277",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1280,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'unzip'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'O_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'P_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1033,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ret' is not equal to ARCHIVE_EOF",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 't_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'v_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'p_opt' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1044,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'extract_stdout'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 857,
                    "column": 18,
                    "event": "note",
                    "message": "Calling 'pathdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'path' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 22,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 251,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'len' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 255,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 7,
                    "event": "note",
                    "message": "Value assigned to 'str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 257,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 261,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'L_opt' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 261,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 262,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 267",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 267,
                    "column": 11,
                    "event": "note",
                    "message": "Array access (from variable 'str') results in a null pointer dereference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  265|   \t\tmemcpy(str, path, len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  266|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  267|-> \tstr[len] = '\\0';",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  268|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  269|   \treturn (str);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 286,
                    "column": 3,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1215,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 18,
                    "event": "note",
                    "message": "'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 26,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1222",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'version_opt' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'argc' is > 'nopts'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'unzip_exclude_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1277",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1280,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'unzip'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'O_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'P_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1033,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ret' is not equal to ARCHIVE_EOF",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 't_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'v_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'p_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 22,
                    "event": "note",
                    "message": "Assuming 'c_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1046,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'extract'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 790,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 798,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 799,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 798,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 800,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 798,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 808,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 125,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'S_ISDIR'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 123,
                    "column": 33,
                    "event": "note",
                    "message": "expanded from macro '__S_ISTYPE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 808,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 816,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 125,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'S_ISDIR'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 123,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro '__S_ISTYPE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 816,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming 'j_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 816,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 823,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 830,
                    "column": 6,
                    "event": "note",
                    "message": "'j_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 830,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 836,
                    "column": 18,
                    "event": "note",
                    "message": "Calling 'pathcat'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 279,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'prefix' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 279,
                    "column": 11,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 281,
                    "column": 7,
                    "event": "note",
                    "message": "Value assigned to 'str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 281,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 281,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 285,
                    "column": 6,
                    "event": "note",
                    "message": "'prefix' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 285,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 286,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  284|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  285|   \tif (prefix) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  286|-> \t\tmemcpy(str, prefix, prelen);\t/* includes zero */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  287|   \t\tstr[prelen - 1] = '/';\t\t/* splat zero */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  288|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 289,
                    "column": 2,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1215,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 18,
                    "event": "note",
                    "message": "'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 26,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1222",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'version_opt' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1232,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1241,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'argc' is > 'nopts'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1246,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1250,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1255,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'unzip_exclude_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1266,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'nopts' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1274,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1277",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1277,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1280,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'unzip'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1002,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1005,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'O_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1007,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'P_arg' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1010,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1016,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1018,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1033,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ret' is not equal to ARCHIVE_EOF",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1035,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming 'acret' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 7,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1037,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 124,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'zipinfo_mode' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1038,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 't_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1039,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'v_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1041,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'p_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 22,
                    "event": "note",
                    "message": "Assuming 'c_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1043,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1046,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'extract'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 790,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 798,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 799,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 798,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 800,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 798,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 808,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 125,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'S_ISDIR'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 123,
                    "column": 33,
                    "event": "note",
                    "message": "expanded from macro '__S_ISTYPE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 808,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 816,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 125,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'S_ISDIR'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/stat.h",
                    "line": 123,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro '__S_ISTYPE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 816,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming 'j_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 816,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 823,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 830,
                    "column": 6,
                    "event": "note",
                    "message": "'j_opt' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 830,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 836,
                    "column": 18,
                    "event": "note",
                    "message": "Calling 'pathcat'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 279,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'prefix' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 279,
                    "column": 11,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 281,
                    "column": 7,
                    "event": "note",
                    "message": "Value assigned to 'str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 281,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 281,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 285,
                    "column": 6,
                    "event": "note",
                    "message": "'prefix' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 285,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 289,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  287|   \t\tstr[prelen - 1] = '/';\t\t/* splat zero */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  288|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  289|-> \tmemcpy(str + prelen, path, len);\t/* includes zero */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  290|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  291|   \treturn (str);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 321,
                    "column": 2,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1212,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1215,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 18,
                    "event": "note",
                    "message": "'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1218,
                    "column": 26,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1217,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1222",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1230,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'getopts'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1119,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1119,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1121,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case 120:'  at line 1176",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 1177,
                    "column": 4,
                    "event": "note",
                    "message": "Calling 'add_pattern'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 317,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 317,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "libarchive-3.7.2/unzip/bsdunzip.c",
                    "line": 321,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  319|   \t\terror(\"malloc()\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  320|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  321|-> \tmemcpy(entry->pattern, pattern, len + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  322|   \tSTAILQ_INSERT_TAIL(list, entry, link);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  323|   }",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
